Loading...
Searching...
No Matches
gtsam::DiscreteFactor Class Referenceabstract
Discrete

## Detailed Description

Base class for discrete probabilistic factors The most general one is the derived DecisionTreeFactor.

DecisionTreeFactor, which represent a discrete distribution over a set of variables.

- Hybrid factors, such as

Inheritance diagram for gtsam::DiscreteFactor:

## Wrapper support

using | Names = DiscreteValues::Names
| Translation table from values to strings.
virtual std::string | markdown (const KeyFormatter &keyFormatter=DefaultKeyFormatter, const Names &names={}) const =0
| Render as markdown table.
virtual std::string | html (const KeyFormatter &keyFormatter=DefaultKeyFormatter, const Names &names={}) const =0
| Render as html table.

## Public Member Functions

Standard Constructors
| DiscreteFactor ()
| Default constructor creates empty factor.
template<typename CONTAINER>
| DiscreteFactor (const CONTAINER &keys)
| Construct from container of keys.
virtual | ~DiscreteFactor ()
| Virtual destructor.
Testable
virtual bool | equals (const DiscreteFactor &lf, double tol=1e-9) const =0
| equals
void | print (const std::string &s="DiscreteFactor\n", const KeyFormatter &formatter=DefaultKeyFormatter) const override
| print
Standard Interface
virtual double | operator() (const DiscreteValues &) const =0
| Find value for given assignment of values to variables.
double | error (const DiscreteValues &values) const
| Error is just -log(value).
double | error (const HybridValues &c) const override
| All factor types need to implement an error function.
virtual DecisionTreeFactor | operator* (const DecisionTreeFactor &) const =0
| Multiply in a DecisionTreeFactor and return the result as DecisionTreeFactor.
virtual DecisionTreeFactor | toDecisionTreeFactor () const =0
Public Member Functions inherited from gtsam::Factor
virtual | ~Factor ()=default
| Default destructor.
bool | empty () const
| Whether the factor is empty (involves zero variables).
Key | front () const
| First key.
Key | back () const
| Last key.
const_iterator | find (Key key) const
| find
const KeyVector & | keys () const
| Access the factor's involved variable keys.
const_iterator | begin () const
| Iterator at beginning of involved variable keys.
const_iterator | end () const
| Iterator at end of involved variable keys.
size_t | size () const
virtual void | printKeys (const std::string &s="Factor", const KeyFormatter &formatter=DefaultKeyFormatter) const
| print only keys
bool | equals (const This &other, double tol=1e-9) const
| check equality
KeyVector & | keys ()
iterator | begin ()
| Iterator at beginning of involved variable keys.
iterator | end ()
| Iterator at end of involved variable keys.

## Public Types

typedef DiscreteFactor | This
| This class.
typedef boost::shared_ptr< DiscreteFactor > | shared_ptr
| shared_ptr to this class
typedef Factor | Base
| Our base class.
using | Values = DiscreteValues
| backwards compatibility
Public Types inherited from gtsam::Factor
typedef KeyVector::iterator | iterator
| Iterator over keys.
typedef KeyVector::const_iterator | const_iterator
| Const iterator over keys.

## Additional Inherited Members

| Factor ()
| Default constructor for I/O.
template<typename CONTAINER>
| Factor (const CONTAINER &keys)
| Construct factor from container of keys.
template<typename ITERATOR>
| Factor (ITERATOR first, ITERATOR last)
| Construct factor from iterator keys.
template<typename CONTAINER>
static Factor | FromKeys (const CONTAINER &keys)
| Construct factor from container of keys.
template<typename ITERATOR>
static Factor | FromIterators (ITERATOR first, ITERATOR last)
| Construct factor from iterator keys.
Protected Attributes inherited from gtsam::Factor
KeyVector | keys_
| The keys involved in this factor.

## Constructor & Destructor Documentation

## DiscreteFactor()

template<typename CONTAINER>

gtsam::DiscreteFactor::DiscreteFactor | ( | const CONTAINER & | keys | ) |

inline

Construct from container of keys.

This constructor is used internally from derived factor constructors, either from a container of keys or from a boost::assign::list_of.

## Member Function Documentation

## equals()

virtual bool gtsam::DiscreteFactor::equals | ( | const DiscreteFactor & | lf,
|  | double | tol = 1e-9 ) const

pure virtual

equals

Implemented in gtsam::DecisionTreeFactor, and gtsam::DiscreteConditional.

## error()

double DiscreteFactor::error | ( | const HybridValues & | c | ) | const

override virtual

All factor types need to implement an error function.

In factor graphs, this is the negative log-likelihood.

Reimplemented from gtsam::Factor.

## html()

virtual std::string gtsam::DiscreteFactor::html | ( | const KeyFormatter & | keyFormatter = DefaultKeyFormatter,
|  | const Names & | names = {} ) const

pure virtual

Render as html table.

Parameters

  keyFormatter | GTSAM-style Key formatter.
  names | optional, category names corresponding to choices.

Returns
  std::string a html string.

Implemented in gtsam::DecisionTreeFactor, and gtsam::DiscreteConditional.

## markdown()

virtual std::string gtsam::DiscreteFactor::markdown | ( | const KeyFormatter & | keyFormatter = DefaultKeyFormatter,
|  | const Names & | names = {} ) const

pure virtual

Render as markdown table.

Parameters

  keyFormatter | GTSAM-style Key formatter.
  names | optional, category names corresponding to choices.

Returns
  std::string a markdown string.

Implemented in gtsam::DecisionTreeFactor, and gtsam::DiscreteConditional.

## operator()()

virtual double gtsam::DiscreteFactor::operator() | ( | const DiscreteValues & |  | ) | const

pure virtual

Find value for given assignment of values to variables.

Implemented in gtsam::DecisionTreeFactor, and gtsam::DiscreteConditional.

## operator*()

virtual DecisionTreeFactor gtsam::DiscreteFactor::operator* | ( | const DecisionTreeFactor & |  | ) | const

pure virtual

Multiply in a DecisionTreeFactor and return the result as DecisionTreeFactor.

Implemented in gtsam::DecisionTreeFactor.

## print()

void gtsam::DiscreteFactor::print | ( | const std::string & | s = "DiscreteFactor\n",
|  | const KeyFormatter & | formatter = DefaultKeyFormatter ) const

inline override virtual

print

Reimplemented from gtsam::Factor.

Reimplemented in gtsam::DiscreteLookupTable.

## toDecisionTreeFactor()

virtual DecisionTreeFactor gtsam::DiscreteFactor::toDecisionTreeFactor | ( |  | ) | const

pure virtual

Implemented in gtsam::DecisionTreeFactor.

The documentation for this class was generated from the following files:

- /build/gtsam-gchP9J/gtsam-4.2.2+dfsg/gtsam/discrete/DiscreteFactor.h
- /build/gtsam-gchP9J/gtsam-4.2.2+dfsg/gtsam/discrete/DiscreteFactor.cpp